"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _mapEvents = _interopRequireDefault(require("./utilities/mapEvents"));

var _debug = _interopRequireDefault(require("debug"));

var _assert = _interopRequireDefault(require("assert"));

var _axios = _interopRequireDefault(require("axios"));

var debug = (0, _debug.default)('geteventstore:getEvents');
var baseErr = 'Get Events - ';

var _default = function _default(config) {
  return (
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(streamName, startPosition, length, direction, resolveLinkTos) {
        var embed,
            options,
            response,
            totalEntries,
            i,
            _args = arguments;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                embed = _args.length > 5 && _args[5] !== undefined ? _args[5] : 'body';
                (0, _assert.default)(streamName, "".concat(baseErr, "Stream Name not provided"));
                length = length || 1000;

                if (length > 4096) {
                  console.warn('WARNING: Max event return limit exceeded. Using the max of 4096');
                  length = 4096;
                }

                direction = direction || 'forward';
                startPosition = startPosition === undefined && direction === 'backward' ? 'head' : startPosition || 0;
                resolveLinkTos = resolveLinkTos === undefined ? true : resolveLinkTos;
                options = {
                  url: "".concat(config.baseUrl, "/streams/").concat(streamName, "/").concat(startPosition, "/").concat(direction, "/").concat(length),
                  method: 'GET',
                  headers: {
                    "Content-Type": "application/vnd.eventstore.events+json",
                    "ES-ResolveLinkTos": resolveLinkTos.toString()
                  },
                  params: {
                    embed: embed
                  },
                  timeout: config.timeout
                };
                debug('', 'Options: ', options);
                _context.next = 11;
                return (0, _axios.default)(options);

              case 11:
                response = _context.sent;

                if (embed === 'body') {
                  totalEntries = response.data.entries.length;

                  for (i = 0; i < totalEntries; i++) {
                    if (response.data.entries[i].data) response.data.entries[i].data = JSON.parse(response.data.entries[i].data);
                  }
                }

                if (!(direction === 'forward')) {
                  _context.next = 15;
                  break;
                }

                return _context.abrupt("return", (0, _mapEvents.default)(response.data.entries.reverse()));

              case 15:
                return _context.abrupt("return", (0, _mapEvents.default)(response.data.entries));

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x, _x2, _x3, _x4, _x5) {
        return _ref.apply(this, arguments);
      };
    }()
  );
};

exports.default = _default;
module.exports = exports.default;